/*********************************************************************************
 *   Kenya - an introductory programming language and development environment    *
 *   Copyright (C) 2001 Robert Chatley                                           *
 *                                                                               *
 *   This program is free software; you can redistribute it and/or               *
 *   modify it under the terms of the GNU General Public License                 *
 *   as published by the Free Software Foundation; either version 2              *
 *   of the License, or (at your option) any later version.                      *
 *                                                                               *
 *   This program is distributed in the hope that it will be useful,             *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of              *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
 *   GNU General Public License for more details.                                *
 *                                                                               *
 *   You should have received a copy of the GNU General Public License           *
 *   along with this program; if not, write to the Free Software                 *
 *   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. *
 *                                                                               *
 *   The author can be contacted by email at robert@chatley.com                  *
 *                                                                               *
 *********************************************************************************/

import javax.swing.*;

public class KenyaToolBar extends JToolBar
{
    KenyaToolBar(KenyaUI ui)
    {
	String slash = System.getProperty( "file.separator" );

	JButton button;


	//get or make a new.gif
        //ImageIcon newIcon = new ImageIcon( ui.prop.getProperty( "kenya.location" ) + slash + "images" + slash + "new.gif"); 

	button = new JButton( "New File" /* , newIcon */ );
	button.addActionListener( new NewListener(ui) );
	add(button);

    ImageIcon openIcon = new ImageIcon( ui.prop.getProperty( "kenya.location" ) + slash + "images" + slash + "open.gif"); 
	button = new JButton( "Open File" , openIcon );
	button.addActionListener( new OpenListener(ui) );
	add(button);

    ImageIcon saveIcon = new ImageIcon( ui.prop.getProperty( "kenya.location" ) + slash +"images" + slash + "save.gif"); 
	button = new JButton( "Save" , saveIcon );
	button.addActionListener( new SaveListener(ui,false) );
	add(button);

	button = new JButton( "Save As" , saveIcon );
	button.addActionListener( new SaveListener(ui,true) );
	add(button);

	button = new JButton("Translate");
	button.addActionListener( new ParseListener(ui) );
	add(button);

	button = new JButton("Compile");
	button.addActionListener( new CompileListener(ui) );
	add(button);

	button = new JButton("Execute");
	button.addActionListener( new ExecuteListener(ui) );
	add(button);

	//button = new JButton("Settings");
	//button.addActionListener( new SettingsListener(ui) );
	//add(button);

	button = new JButton("Help");
	button.addActionListener( new HelpListener(ui) );
	add(button);

	button = new JButton("Quit");
	button.addActionListener( new QuitListener(ui) );
	add(button);
    }
}
