package kenya.io;

import java.io.*;

public class InputReader {
    static InputStreamReader isr;
    static StreamTokenizer tokenizer;

    static {
        isr =  new InputStreamReader( System.in );
        tokenizer = new StreamTokenizer( isr );
        allChars();
        //tokenizer.resetSyntax();
        //tokenizer.whitespaceChars( 0, ' ' );
        //tokenizer.wordChars( 33 , 255 );
    }

    public static boolean isEOF() {
        //tokenizer.resetSyntax();

        try {
            if (tokenizer.nextToken() == StreamTokenizer.TT_EOF) {
                return true;
            } else {
                //System.out.println("Token :"+tokenizer.sval.length()+" "+tokenizer.sval+"::");
                tokenizer.pushBack();
                return false;                                  
            }
        } catch (java.io.IOException e) {
            System.out.println(e);
        }
        return false;
    }


    private static void allChars() {
        tokenizer.resetSyntax();
        tokenizer.whitespaceChars( 0 , 0 );
        tokenizer.ordinaryChars( 0 , 255 );
    }



    public static int readInt() {

        try {

            tokenizer.resetSyntax();
            tokenizer.whitespaceChars( 0 , ' ' );
            tokenizer.wordChars( '0' , '9' );

            if ( tokenizer.nextToken() == StreamTokenizer.TT_EOF ) {
                System.out.println("End Of File found.");
            } else {
                return(int)Double.parseDouble(tokenizer.sval);
            }
        } catch (NumberFormatException nfe) {
            System.out.println("Could not read integer, incorrectly formatted number (" + tokenizer.sval + ")" );
        } catch (java.io.IOException e) {
            System.out.println(e);
        }

        return 0;
    } 


    /*
    public static int readInt() {

       tokenizer.resetSyntax();
       tokenizer.whitespaceChars( 0 , ' ' );
       tokenizer.wordChars('0','9');


        try {


            if ( tokenizer.nextToken() == StreamTokenizer.TT_EOF ) {
                System.out.println("End Of File found.");
            } else {
                return(int)Double.parseDouble(tokenizer.sval);
            }
        } catch (NumberFormatException nfe) {
            System.out.println("Could not read integer, incorrectly formatted number (" + tokenizer.sval + ")" ); System.exit(1);
        } catch (java.io.IOException e) {
            System.out.println(e);
        }

        return 0;
    } 
      */
    public static double readDouble() {

        try {

            tokenizer.resetSyntax();
            tokenizer.whitespaceChars( 0 , ' ' );
            tokenizer.wordChars('0','9');
            tokenizer.wordChars('.','.');

            if ( tokenizer.nextToken() == StreamTokenizer.TT_EOF ) {
                System.out.println("End Of File found.");
            } else {
                return Double.parseDouble(tokenizer.sval);
            }
        } catch (NumberFormatException nfe) {
            System.out.println("Could not read double, incorrectly formatted number (" + tokenizer.sval + ")" );
        } catch (java.io.IOException e) {
            System.out.println(e);
        }

        return 0.0;
    }

    public static String readString() {


        try {

            tokenizer.resetSyntax();
            tokenizer.whitespaceChars( 0 , ' ' );
            tokenizer.wordChars(33,255);


            if ( tokenizer.nextToken() == StreamTokenizer.TT_EOF ) {
                System.out.println("End Of File found."); 
            } else {
                return tokenizer.sval;
            }
        } catch (java.io.IOException e) {
            System.out.println(e);
        }

        return "";
    }


    private static char readPrimitive() {

        try {
            if ( tokenizer.nextToken() == StreamTokenizer.TT_EOF ) {
                System.out.println("End Of File found."); 
            } else if (tokenizer.ttype == StreamTokenizer.TT_EOL) {
                return '\n';
            } else if (tokenizer.ttype == StreamTokenizer.TT_NUMBER) {
                return(char)tokenizer.nval;
            } else if (tokenizer.ttype == StreamTokenizer.TT_WORD) {
                return(char)tokenizer.sval.charAt(0);
            } else {
                return(char)tokenizer.ttype;
            }
        } catch (java.io.IOException e) {
            System.out.println(e);
        }
        return ' ';
    }

    public static char readChar() {
        tokenizer.resetSyntax();
        tokenizer.whitespaceChars( ' ' , ' ' );
        return readPrimitive();

    }

    public static char read() {
        allChars();
        return readPrimitive();
    }

}
