/* This file was generated by SableCC (http://www.sablecc.org/). */

package minijava.lexer;

import java.io.*;
import java.util.*;
import minijava.node.*;

public class Lexer
{
    protected Token token;
    protected State state = State.INITIAL;

    private PushbackReader in;
    private int line;
    private int pos;
    private boolean cr;
    private boolean eof;
    private final StringBuffer text = new StringBuffer();

    protected void filter() throws LexerException, IOException
    {
    }

    public Lexer(PushbackReader in)
    {
        this.in = in;

        if(gotoTable == null)
        {
            try
            {
                DataInputStream s = new DataInputStream(
                    new BufferedInputStream(
                    Lexer.class.getResourceAsStream("lexer.dat")));

                // read gotoTable
                int length = s.readInt();
                gotoTable = new int[length][][][];
                for(int i = 0; i < gotoTable.length; i++)
                {
                    length = s.readInt();
                    gotoTable[i] = new int[length][][];
                    for(int j = 0; j < gotoTable[i].length; j++)
                    {
                        length = s.readInt();
                        gotoTable[i][j] = new int[length][3];
                        for(int k = 0; k < gotoTable[i][j].length; k++)
                        {
                            for(int l = 0; l < 3; l++)
                            {
                                gotoTable[i][j][k][l] = s.readInt();
                            }
                        }
                    }
                }

                // read accept
                length = s.readInt();
                accept = new int[length][];
                for(int i = 0; i < accept.length; i++)
                {
                    length = s.readInt();
                    accept[i] = new int[length];
                    for(int j = 0; j < accept[i].length; j++)
                    {
                        accept[i][j] = s.readInt();
                    }
                }

                s.close();
            }
            catch(Exception e)
            {
                throw new RuntimeException("The file \"lexer.dat\" is either missing or corrupted.");
            }
        }
    }

    public Token peek() throws LexerException, IOException
    {
        while(token == null)
        {
            token = getToken();
            filter();
        }

        return token;
    }

    public Token next() throws LexerException, IOException
    {
        while(token == null)
        {
            token = getToken();
            filter();
        }

        Token result = token;
        token = null;
        return result;
    }

    protected Token getToken() throws IOException, LexerException
    {
        int dfa_state = 0;

        int start_pos = pos;
        int start_line = line;

        int accept_state = -1;
        int accept_token = -1;
        int accept_length = -1;
        int accept_pos = -1;
        int accept_line = -1;

        int[][][] gotoTable = this.gotoTable[state.id()];
        int[] accept = this.accept[state.id()];
        text.setLength(0);

        while(true)
        {
            int c = getChar();

            if(c != -1)
            {
                switch(c)
                {
                case 10:
                    if(cr)
                    {
                        cr = false;
                    }
                    else
                    {
                        line++;
                        pos = 0;
                    }
                    break;
                case 13:
                    line++;
                    pos = 0;
                    cr = true;
                    break;
                default:
                    pos++;
                    cr = false;
                    break;
                };

                text.append((char) c);

                do
                {
                    int oldState = (dfa_state < -1) ? (-2 -dfa_state) : dfa_state;

                    dfa_state = -1;

                    int[][] tmp1 =  gotoTable[oldState];
                    int low = 0;
                    int high = tmp1.length - 1;

                    while(low <= high)
                    {
                        int middle = (low + high) / 2;
                        int[] tmp2 = tmp1[middle];

                        if(c < tmp2[0])
                        {
                            high = middle - 1;
                        }
                        else if(c > tmp2[1])
                        {
                            low = middle + 1;
                        }
                        else
                        {
                            dfa_state = tmp2[2];
                            break;
                        }
                    }
                }while(dfa_state < -1);
            }
            else
            {
                dfa_state = -1;
            }

            if(dfa_state >= 0)
            {
                if(accept[dfa_state] != -1)
                {
                    accept_state = dfa_state;
                    accept_token = accept[dfa_state];
                    accept_length = text.length();
                    accept_pos = pos;
                    accept_line = line;
                }
            }
            else
            {
                if(accept_state != -1)
                {
                    switch(accept_token)
                    {
                    case 0:
                        {
                            Token token = new0(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 1:
                        {
                            Token token = new1(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 2:
                        {
                            Token token = new2(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 3:
                        {
                            Token token = new3(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 4:
                        {
                            Token token = new4(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 5:
                        {
                            Token token = new5(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 6:
                        {
                            Token token = new6(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 7:
                        {
                            Token token = new7(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 8:
                        {
                            Token token = new8(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 9:
                        {
                            Token token = new9(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 10:
                        {
                            Token token = new10(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 11:
                        {
                            Token token = new11(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 12:
                        {
                            Token token = new12(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 13:
                        {
                            Token token = new13(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 14:
                        {
                            Token token = new14(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 15:
                        {
                            Token token = new15(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 16:
                        {
                            Token token = new16(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 17:
                        {
                            Token token = new17(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 18:
                        {
                            Token token = new18(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 19:
                        {
                            Token token = new19(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 20:
                        {
                            Token token = new20(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 21:
                        {
                            Token token = new21(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 22:
                        {
                            Token token = new22(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 23:
                        {
                            Token token = new23(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 24:
                        {
                            Token token = new24(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 25:
                        {
                            Token token = new25(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 26:
                        {
                            Token token = new26(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 27:
                        {
                            Token token = new27(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 28:
                        {
                            Token token = new28(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 29:
                        {
                            Token token = new29(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 30:
                        {
                            Token token = new30(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 31:
                        {
                            Token token = new31(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 32:
                        {
                            Token token = new32(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 33:
                        {
                            Token token = new33(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 34:
                        {
                            Token token = new34(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 35:
                        {
                            Token token = new35(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 36:
                        {
                            Token token = new36(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 37:
                        {
                            Token token = new37(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 38:
                        {
                            Token token = new38(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 39:
                        {
                            Token token = new39(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 40:
                        {
                            Token token = new40(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 41:
                        {
                            Token token = new41(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 42:
                        {
                            Token token = new42(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 43:
                        {
                            Token token = new43(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 44:
                        {
                            Token token = new44(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 45:
                        {
                            Token token = new45(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 46:
                        {
                            Token token = new46(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 47:
                        {
                            Token token = new47(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 48:
                        {
                            Token token = new48(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 49:
                        {
                            Token token = new49(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 50:
                        {
                            Token token = new50(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 51:
                        {
                            Token token = new51(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 52:
                        {
                            Token token = new52(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 53:
                        {
                            Token token = new53(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 54:
                        {
                            Token token = new54(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 55:
                        {
                            Token token = new55(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 56:
                        {
                            Token token = new56(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 57:
                        {
                            Token token = new57(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 58:
                        {
                            Token token = new58(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 59:
                        {
                            Token token = new59(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 60:
                        {
                            Token token = new60(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 61:
                        {
                            Token token = new61(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 62:
                        {
                            Token token = new62(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 63:
                        {
                            Token token = new63(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 64:
                        {
                            Token token = new64(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 65:
                        {
                            Token token = new65(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 66:
                        {
                            Token token = new66(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 67:
                        {
                            Token token = new67(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 68:
                        {
                            Token token = new68(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 69:
                        {
                            Token token = new69(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 70:
                        {
                            Token token = new70(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 71:
                        {
                            Token token = new71(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 72:
                        {
                            Token token = new72(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 73:
                        {
                            Token token = new73(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 74:
                        {
                            Token token = new74(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 75:
                        {
                            Token token = new75(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 76:
                        {
                            Token token = new76(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 77:
                        {
                            Token token = new77(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 78:
                        {
                            Token token = new78(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 79:
                        {
                            Token token = new79(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 80:
                        {
                            Token token = new80(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 81:
                        {
                            Token token = new81(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 82:
                        {
                            Token token = new82(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 83:
                        {
                            Token token = new83(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 84:
                        {
                            Token token = new84(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 85:
                        {
                            Token token = new85(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 86:
                        {
                            Token token = new86(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 87:
                        {
                            Token token = new87(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 88:
                        {
                            Token token = new88(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 89:
                        {
                            Token token = new89(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 90:
                        {
                            Token token = new90(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 91:
                        {
                            Token token = new91(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 92:
                        {
                            Token token = new92(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 93:
                        {
                            Token token = new93(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    }
                }
                else
                {
                    if(text.length() > 0)
                    {
                        throw new LexerException(
                            "[" + (start_line + 1) + "," + (start_pos + 1) + "]" +
                            " Unknown token: " + text,start_line+1);
                    }
                    else
                    {
                        EOF token = new EOF(
                            start_line + 1,
                            start_pos + 1);
                        return token;
                    }
                }
            }
        }
    }

    Token new0(String text, int line, int pos) { return new TNewLine(text, line, pos); }
    Token new1(String text, int line, int pos) { return new TBlank(text, line, pos); }
    Token new2(String text, int line, int pos) { return new TComment(text, line, pos); }
    Token new3(int line, int pos) { return new TBoolean(line, pos); }
    Token new4(int line, int pos) { return new TChar(line, pos); }
    Token new5(int line, int pos) { return new TInt(line, pos); }
    Token new6(int line, int pos) { return new TReal(line, pos); }
    Token new7(int line, int pos) { return new TString(line, pos); }
    Token new8(int line, int pos) { return new TVoid(line, pos); }
    Token new9(int line, int pos) { return new TKlass(line, pos); }
    Token new10(int line, int pos) { return new TConst(line, pos); }
    Token new11(int line, int pos) { return new TPrint(line, pos); }
    Token new12(int line, int pos) { return new TPrintln(line, pos); }
    Token new13(int line, int pos) { return new TIf(line, pos); }
    Token new14(int line, int pos) { return new TElse(line, pos); }
    Token new15(int line, int pos) { return new TWhile(line, pos); }
    Token new16(int line, int pos) { return new TReturn(line, pos); }
    Token new17(int line, int pos) { return new TSwitch(line, pos); }
    Token new18(int line, int pos) { return new TCase(line, pos); }
    Token new19(int line, int pos) { return new TBreak(line, pos); }
    Token new20(int line, int pos) { return new TDefault(line, pos); }
    Token new21(int line, int pos) { return new TFor(line, pos); }
    Token new22(int line, int pos) { return new TTo(line, pos); }
    Token new23(int line, int pos) { return new TStep(line, pos); }
    Token new24(int line, int pos) { return new TDecreasing(line, pos); }
    Token new25(int line, int pos) { return new TAssert(line, pos); }
    Token new26(int line, int pos) { return new TArraycopy(line, pos); }
    Token new27(int line, int pos) { return new TTrue(line, pos); }
    Token new28(int line, int pos) { return new TFalse(line, pos); }
    Token new29(int line, int pos) { return new TNull(line, pos); }
    Token new30(String text, int line, int pos) { return new TAnd(text, line, pos); }
    Token new31(String text, int line, int pos) { return new TOr(text, line, pos); }
    Token new32(int line, int pos) { return new TXor(line, pos); }
    Token new33(String text, int line, int pos) { return new TNot(text, line, pos); }
    Token new34(int line, int pos) { return new TSin(line, pos); }
    Token new35(int line, int pos) { return new TCos(line, pos); }
    Token new36(int line, int pos) { return new TTan(line, pos); }
    Token new37(int line, int pos) { return new TAsin(line, pos); }
    Token new38(int line, int pos) { return new TAcos(line, pos); }
    Token new39(int line, int pos) { return new TAtan(line, pos); }
    Token new40(int line, int pos) { return new TSqrt(line, pos); }
    Token new41(int line, int pos) { return new TLog(line, pos); }
    Token new42(int line, int pos) { return new TExp(line, pos); }
    Token new43(int line, int pos) { return new TRandom(line, pos); }
    Token new44(int line, int pos) { return new TRound(line, pos); }
    Token new45(int line, int pos) { return new TAbs(line, pos); }
    Token new46(int line, int pos) { return new TFloor(line, pos); }
    Token new47(int line, int pos) { return new TCeil(line, pos); }
    Token new48(int line, int pos) { return new TRead(line, pos); }
    Token new49(int line, int pos) { return new TReadint(line, pos); }
    Token new50(int line, int pos) { return new TReadreal(line, pos); }
    Token new51(int line, int pos) { return new TReadstring(line, pos); }
    Token new52(int line, int pos) { return new TReadchar(line, pos); }
    Token new53(int line, int pos) { return new TEndoffile(line, pos); }
    Token new54(int line, int pos) { return new TDrawbox(line, pos); }
    Token new55(int line, int pos) { return new TDrawtriangle(line, pos); }
    Token new56(int line, int pos) { return new TDrawellipse(line, pos); }
    Token new57(int line, int pos) { return new TDrawline(line, pos); }
    Token new58(int line, int pos) { return new TDrawstring(line, pos); }
    Token new59(int line, int pos) { return new TClear(line, pos); }
    Token new60(int line, int pos) { return new TSetcolour(line, pos); }
    Token new61(int line, int pos) { return new TSetbgcolour(line, pos); }
    Token new62(int line, int pos) { return new TFill(line, pos); }
    Token new63(String text, int line, int pos) { return new TIdentifier(text, line, pos); }
    Token new64(String text, int line, int pos) { return new TStringliteral(text, line, pos); }
    Token new65(String text, int line, int pos) { return new TCharliteral(text, line, pos); }
    Token new66(int line, int pos) { return new TLParenthese(line, pos); }
    Token new67(int line, int pos) { return new TRParenthese(line, pos); }
    Token new68(int line, int pos) { return new TLBrace(line, pos); }
    Token new69(int line, int pos) { return new TRBrace(line, pos); }
    Token new70(int line, int pos) { return new TLBracket(line, pos); }
    Token new71(int line, int pos) { return new TRBracket(line, pos); }
    Token new72(int line, int pos) { return new TBracketPair(line, pos); }
    Token new73(int line, int pos) { return new TSemicolon(line, pos); }
    Token new74(int line, int pos) { return new TColon(line, pos); }
    Token new75(int line, int pos) { return new TComma(line, pos); }
    Token new76(String text, int line, int pos) { return new TDot(text, line, pos); }
    Token new77(int line, int pos) { return new TPlus(line, pos); }
    Token new78(int line, int pos) { return new TPlusplus(line, pos); }
    Token new79(int line, int pos) { return new TMinus(line, pos); }
    Token new80(int line, int pos) { return new TMinusminus(line, pos); }
    Token new81(int line, int pos) { return new TTimes(line, pos); }
    Token new82(int line, int pos) { return new TDivide(line, pos); }
    Token new83(int line, int pos) { return new TPower(line, pos); }
    Token new84(int line, int pos) { return new TMod(line, pos); }
    Token new85(int line, int pos) { return new TLess(line, pos); }
    Token new86(int line, int pos) { return new TLessequal(line, pos); }
    Token new87(int line, int pos) { return new TGreater(line, pos); }
    Token new88(int line, int pos) { return new TGreaterequal(line, pos); }
    Token new89(int line, int pos) { return new TEqual(line, pos); }
    Token new90(int line, int pos) { return new TNotequal(line, pos); }
    Token new91(int line, int pos) { return new TAssign(line, pos); }
    Token new92(String text, int line, int pos) { return new TIntnumber(text, line, pos); }
    Token new93(String text, int line, int pos) { return new TFpnumber(text, line, pos); }

    private int getChar() throws IOException
    {
        if(eof)
        {
            return -1;
        }

        int result = in.read();

        if(result == -1)
        {
            eof = true;
        }

        return result;
    }

    private void pushBack(int acceptLength) throws IOException
    {
        int length = text.length();
        for(int i = length - 1; i >= acceptLength; i--)
        {
            eof = false;

            in.unread(text.charAt(i));
        }
    }

    protected void unread(Token token) throws IOException
    {
        String text = token.getText();
        int length = text.length();

        for(int i = length - 1; i >= 0; i--)
        {
            eof = false;

            in.unread(text.charAt(i));
        }

        pos = token.getPos() - 1;
        line = token.getLine() - 1;
    }

    private String getText(int acceptLength)
    {
        StringBuffer s = new StringBuffer(acceptLength);
        for(int i = 0; i < acceptLength; i++)
        {
            s.append(text.charAt(i));
        }

        return s.toString();
    }

    private static int[][][][] gotoTable;
/*  {
        { // INITIAL
            {{9, 9, 1}, {10, 10, 2}, {13, 13, 3}, {32, 32, 4}, {33, 33, 5}, {34, 34, 6}, {37, 37, 7}, {38, 38, 8}, {39, 39, 9}, {40, 40, 10}, {41, 41, 11}, {42, 42, 12}, {43, 43, 13}, {44, 44, 14}, {45, 45, 15}, {46, 46, 16}, {47, 47, 17}, {48, 57, 18}, {58, 58, 19}, {59, 59, 20}, {60, 60, 21}, {61, 61, 22}, {62, 62, 23}, {65, 82, 24}, {83, 83, 25}, {84, 90, 24}, {91, 91, 26}, {93, 93, 27}, {94, 94, 28}, {97, 97, 29}, {98, 98, 30}, {99, 99, 31}, {100, 100, 32}, {101, 101, 33}, {102, 102, 34}, {103, 104, 35}, {105, 105, 36}, {106, 107, 35}, {108, 108, 37}, {109, 109, 35}, {110, 110, 38}, {111, 111, 39}, {112, 112, 40}, {113, 113, 35}, {114, 114, 41}, {115, 115, 42}, {116, 116, 43}, {117, 117, 35}, {118, 118, 44}, {119, 119, 45}, {120, 120, 46}, {121, 122, 35}, {123, 123, 47}, {124, 124, 48}, {125, 125, 49}, },
            {{9, 9, 1}, {32, 32, 4}, },
            {},
            {{10, 10, 50}, },
            {{9, 32, -3}, },
            {{61, 61, 51}, },
            {{32, 33, 52}, {34, 34, 53}, {35, 127, 52}, },
            {},
            {{38, 38, 54}, },
            {{32, 38, 55}, {40, 91, 55}, {92, 92, 56}, {93, 127, 55}, },
            {},
            {},
            {},
            {{43, 43, 57}, },
            {},
            {{45, 45, 58}, },
            {},
            {{47, 47, 59}, },
            {{46, 46, 60}, {48, 57, 18}, },
            {},
            {},
            {{61, 61, 61}, },
            {{61, 61, 62}, },
            {{61, 61, 63}, },
            {{48, 57, 64}, {65, 90, 65}, {97, 122, 66}, },
            {{48, 90, -26}, {97, 115, 66}, {116, 116, 67}, {117, 122, 66}, },
            {{32, 32, 68}, },
            {},
            {},
            {{48, 90, -26}, {97, 97, 66}, {98, 98, 69}, {99, 99, 70}, {100, 109, 66}, {110, 110, 71}, {111, 113, 66}, {114, 114, 72}, {115, 115, 73}, {116, 116, 74}, {117, 122, 66}, },
            {{48, 90, -26}, {97, 110, 66}, {111, 111, 75}, {112, 113, 66}, {114, 114, 76}, {115, 122, 66}, },
            {{48, 90, -26}, {97, 97, 77}, {98, 100, 66}, {101, 101, 78}, {102, 103, 66}, {104, 104, 79}, {105, 107, 66}, {108, 108, 80}, {109, 110, 66}, {111, 111, 81}, {112, 122, 66}, },
            {{48, 90, -26}, {97, 100, 66}, {101, 101, 82}, {102, 110, 66}, {111, 111, 83}, {112, 113, 66}, {114, 114, 84}, {115, 122, 66}, },
            {{48, 90, -26}, {97, 107, 66}, {108, 108, 85}, {109, 119, 66}, {120, 120, 86}, {121, 122, 66}, },
            {{48, 90, -26}, {97, 97, 87}, {98, 104, 66}, {105, 105, 88}, {106, 107, 66}, {108, 108, 89}, {109, 110, 66}, {111, 111, 90}, {112, 122, 66}, },
            {{48, 122, -26}, },
            {{48, 90, -26}, {97, 101, 66}, {102, 102, 91}, {103, 109, 66}, {110, 110, 92}, {111, 114, 66}, {115, 115, 93}, {116, 122, 66}, },
            {{48, 110, -32}, {111, 111, 94}, {112, 122, 66}, },
            {{48, 110, -32}, {111, 111, 95}, {112, 116, 66}, {117, 117, 96}, {118, 122, 66}, },
            {{48, 90, -26}, {97, 113, 66}, {114, 114, 97}, {115, 122, 66}, },
            {{48, 113, -41}, {114, 114, 98}, {115, 122, 66}, },
            {{48, 90, -26}, {97, 97, 99}, {98, 100, 66}, {101, 101, 100}, {102, 110, 66}, {111, 111, 101}, {112, 122, 66}, },
            {{48, 100, -34}, {101, 101, 102}, {102, 104, 66}, {105, 105, 103}, {106, 112, 66}, {113, 113, 104}, {114, 115, 66}, {116, 116, 105}, {117, 118, 66}, {119, 119, 106}, {120, 122, 66}, },
            {{48, 90, -26}, {97, 97, 107}, {98, 110, 66}, {111, 111, 108}, {112, 113, 66}, {114, 114, 109}, {115, 122, 66}, },
            {{48, 110, -32}, {111, 111, 110}, {112, 122, 66}, },
            {{48, 90, -26}, {97, 103, 66}, {104, 104, 111}, {105, 122, 66}, },
            {{48, 110, -32}, {111, 111, 112}, {112, 122, 66}, },
            {},
            {{124, 124, 113}, },
            {},
            {},
            {},
            {{32, 127, -8}, },
            {},
            {},
            {{39, 39, 114}, },
            {{34, 34, 115}, {39, 39, 116}, {92, 92, 117}, {98, 98, 118}, {102, 102, 119}, {110, 110, 120}, {114, 114, 121}, {116, 116, 122}, },
            {},
            {},
            {{10, 10, 123}, {13, 13, 124}, {32, 127, 125}, },
            {{48, 57, 126}, },
            {},
            {},
            {},
            {{48, 122, -26}, },
            {{48, 122, -26}, },
            {{48, 122, -26}, },
            {{48, 113, -41}, {114, 114, 127}, {115, 122, 66}, },
            {{93, 93, 128}, },
            {{48, 90, -26}, {97, 114, 66}, {115, 115, 129}, {116, 122, 66}, },
            {{48, 110, -32}, {111, 111, 130}, {112, 122, 66}, },
            {{48, 90, -26}, {97, 99, 66}, {100, 100, 131}, {101, 122, 66}, },
            {{48, 113, -41}, {114, 114, 132}, {115, 122, 66}, },
            {{48, 90, -26}, {97, 104, 66}, {105, 105, 133}, {106, 114, 66}, {115, 115, 134}, {116, 122, 66}, },
            {{48, 90, -26}, {97, 97, 135}, {98, 122, 66}, },
            {{48, 110, -32}, {111, 111, 136}, {112, 122, 66}, },
            {{48, 100, -34}, {101, 101, 137}, {102, 122, 66}, },
            {{48, 114, -71}, {115, 115, 138}, {116, 122, 66}, },
            {{48, 104, -75}, {105, 105, 139}, {106, 122, 66}, },
            {{48, 90, -26}, {97, 97, 140}, {98, 122, 66}, },
            {{48, 90, -26}, {97, 97, 141}, {98, 100, 66}, {101, 101, 142}, {102, 122, 66}, },
            {{48, 90, -26}, {97, 109, 66}, {110, 110, 143}, {111, 114, 66}, {115, 115, 144}, {116, 122, 66}, },
            {{48, 90, -26}, {97, 98, 66}, {99, 99, 145}, {100, 101, 66}, {102, 102, 146}, {103, 122, 66}, },
            {{48, 90, -26}, {97, 116, 66}, {117, 117, 147}, {118, 122, 66}, },
            {{48, 90, -26}, {97, 97, 148}, {98, 122, 66}, },
            {{48, 114, -71}, {115, 115, 149}, {116, 122, 66}, },
            {{48, 90, -26}, {97, 111, 66}, {112, 112, 150}, {113, 122, 66}, },
            {{48, 107, -35}, {108, 108, 151}, {109, 122, 66}, },
            {{48, 107, -35}, {108, 108, 152}, {109, 122, 66}, },
            {{48, 110, -32}, {111, 111, 153}, {112, 122, 66}, },
            {{48, 113, -41}, {114, 114, 154}, {115, 122, 66}, },
            {{48, 122, -26}, },
            {{48, 115, -27}, {116, 116, 155}, {117, 122, 66}, },
            {{48, 57, 64}, {65, 68, 65}, {69, 69, 156}, {70, 90, 65}, {97, 122, 66}, },
            {{48, 90, -26}, {97, 102, 66}, {103, 103, 157}, {104, 122, 66}, },
            {{48, 115, -27}, {116, 116, 158}, {117, 122, 66}, },
            {{48, 107, -35}, {108, 108, 159}, {109, 122, 66}, },
            {{48, 122, -26}, },
            {{48, 104, -75}, {105, 105, 160}, {106, 122, 66}, },
            {{48, 109, -83}, {110, 110, 161}, {111, 122, 66}, },
            {{48, 90, -26}, {97, 97, 162}, {98, 115, 66}, {116, 116, 163}, {117, 122, 66}, },
            {{48, 116, -85}, {117, 117, 164}, {118, 122, 66}, },
            {{48, 115, -27}, {116, 116, 165}, {117, 122, 66}, },
            {{48, 109, -83}, {110, 110, 166}, {111, 122, 66}, },
            {{48, 113, -41}, {114, 114, 167}, {115, 122, 66}, },
            {{48, 100, -34}, {101, 101, 168}, {102, 122, 66}, },
            {{48, 104, -75}, {105, 105, 169}, {106, 122, 66}, },
            {{48, 109, -83}, {110, 110, 170}, {111, 122, 66}, },
            {{48, 122, -26}, },
            {{48, 116, -85}, {117, 117, 171}, {118, 122, 66}, },
            {{48, 104, -75}, {105, 105, 172}, {106, 122, 66}, },
            {{48, 104, -75}, {105, 105, 173}, {106, 122, 66}, },
            {{48, 113, -41}, {114, 114, 174}, {115, 122, 66}, },
            {},
            {},
            {{39, 39, 175}, },
            {{39, 39, 175}, },
            {{39, 39, 175}, },
            {{39, 39, 175}, },
            {{39, 39, 175}, },
            {{39, 39, 175}, },
            {{39, 39, 175}, },
            {{39, 39, 175}, },
            {},
            {{10, 10, 176}, },
            {{10, 127, -61}, },
            {{48, 57, 126}, },
            {{48, 104, -75}, {105, 105, 177}, {106, 122, 66}, },
            {},
            {{48, 122, -26}, },
            {{48, 114, -71}, {115, 115, 178}, {116, 122, 66}, },
            {{48, 122, -26}, },
            {{48, 90, -26}, {97, 97, 179}, {98, 122, 66}, },
            {{48, 109, -83}, {110, 110, 180}, {111, 122, 66}, },
            {{48, 100, -34}, {101, 101, 181}, {102, 122, 66}, },
            {{48, 109, -83}, {110, 110, 182}, {111, 122, 66}, },
            {{48, 107, -35}, {108, 108, 183}, {109, 122, 66}, },
            {{48, 90, -26}, {97, 97, 184}, {98, 122, 66}, },
            {{48, 100, -34}, {101, 101, 185}, {102, 122, 66}, },
            {{48, 107, -35}, {108, 108, 186}, {109, 122, 66}, },
            {{48, 113, -41}, {114, 114, 187}, {115, 122, 66}, },
            {{48, 114, -71}, {115, 115, 188}, {116, 122, 66}, },
            {{48, 90, -26}, {97, 97, 189}, {98, 122, 66}, },
            {{48, 114, -71}, {115, 115, 190}, {116, 122, 66}, },
            {{48, 122, -26}, },
            {{48, 113, -41}, {114, 114, 191}, {115, 122, 66}, },
            {{48, 90, -26}, {97, 97, 192}, {98, 122, 66}, },
            {{48, 97, -31}, {98, 98, 193}, {99, 122, 66}, },
            {{48, 90, -26}, {97, 118, 66}, {119, 119, 194}, {120, 122, 66}, },
            {{48, 100, -34}, {101, 101, 195}, {102, 122, 66}, },
            {{48, 122, -26}, },
            {{48, 114, -71}, {115, 115, 196}, {116, 122, 66}, },
            {{48, 107, -35}, {108, 108, 197}, {109, 122, 66}, },
            {{48, 110, -32}, {111, 111, 198}, {112, 122, 66}, },
            {{48, 122, -26}, },
            {{48, 122, -26}, },
            {{48, 57, 64}, {65, 78, 65}, {79, 79, 199}, {80, 90, 65}, {97, 122, 66}, },
            {{48, 122, -26}, },
            {{48, 122, -26}, },
            {{48, 107, -35}, {108, 108, 200}, {109, 122, 66}, },
            {{48, 109, -83}, {110, 110, 201}, {111, 122, 66}, },
            {{48, 99, -73}, {100, 100, 202}, {101, 122, 66}, },
            {{48, 99, -73}, {100, 100, 203}, {101, 122, 66}, },
            {{48, 116, -85}, {117, 117, 204}, {118, 122, 66}, },
            {{48, 109, -83}, {110, 110, 205}, {111, 122, 66}, },
            {{48, 57, 64}, {65, 65, 65}, {66, 66, 206}, {67, 67, 207}, {68, 90, 65}, {97, 122, 66}, },
            {{48, 122, -26}, },
            {{48, 115, -27}, {116, 116, 208}, {117, 122, 66}, },
            {{48, 111, -88}, {112, 112, 209}, {113, 122, 66}, },
            {{48, 115, -27}, {116, 116, 210}, {117, 122, 66}, },
            {{48, 122, -26}, },
            {{48, 100, -34}, {101, 101, 211}, {102, 122, 66}, },
            {{48, 99, -73}, {100, 100, 212}, {101, 122, 66}, },
            {{48, 107, -35}, {108, 108, 213}, {109, 122, 66}, },
            {{48, 122, -26}, },
            {},
            {},
            {{48, 109, -83}, {110, 110, 214}, {111, 122, 66}, },
            {{48, 122, -26}, },
            {{48, 90, -26}, {97, 120, 66}, {121, 121, 215}, {122, 122, 66}, },
            {{48, 122, -26}, },
            {{48, 113, -41}, {114, 114, 216}, {115, 122, 66}, },
            {{48, 122, -26}, },
            {{48, 100, -34}, {101, 101, 217}, {102, 122, 66}, },
            {{48, 90, -26}, {97, 106, 66}, {107, 107, 218}, {108, 122, 66}, },
            {{48, 122, -26}, },
            {{48, 122, -26}, },
            {{48, 122, -26}, },
            {{48, 114, -71}, {115, 115, 219}, {116, 122, 66}, },
            {{48, 113, -41}, {114, 114, 220}, {115, 122, 66}, },
            {{48, 115, -27}, {116, 116, 221}, {117, 122, 66}, },
            {{48, 100, -34}, {101, 101, 222}, {102, 122, 66}, },
            {{48, 116, -85}, {117, 117, 223}, {118, 122, 66}, },
            {{48, 107, -35}, {108, 108, 224}, {109, 122, 66}, },
            {{48, 65, -167}, {66, 66, 225}, {67, 68, 65}, {69, 69, 226}, {70, 75, 65}, {76, 76, 227}, {77, 82, 65}, {83, 83, 228}, {84, 84, 229}, {85, 90, 65}, {97, 122, 66}, },
            {{48, 122, -26}, },
            {{48, 100, -34}, {101, 101, 230}, {102, 122, 66}, },
            {{48, 122, -26}, },
            {{48, 113, -41}, {114, 114, 231}, {115, 122, 66}, },
            {{48, 57, 64}, {65, 69, 65}, {70, 70, 232}, {71, 90, 65}, {97, 122, 66}, },
            {{48, 122, -26}, },
            {{48, 115, -27}, {116, 116, 233}, {117, 122, 66}, },
            {{48, 110, -32}, {111, 111, 234}, {112, 122, 66}, },
            {{40, 40, 235}, {48, 57, 64}, {65, 66, 65}, {67, 67, 236}, {68, 68, 237}, {69, 72, 65}, {73, 73, 238}, {74, 82, 65}, {83, 83, 239}, {84, 90, 65}, {97, 122, 66}, },
            {{48, 113, -41}, {114, 114, 240}, {115, 122, 66}, },
            {{48, 99, -73}, {100, 100, 241}, {101, 122, 66}, },
            {{48, 57, 64}, {65, 70, 65}, {71, 71, 242}, {72, 90, 65}, {97, 122, 66}, },
            {{48, 110, -32}, {111, 111, 243}, {112, 122, 66}, },
            {{48, 122, -26}, },
            {{48, 122, -26}, },
            {{48, 98, -84}, {99, 99, 244}, {100, 122, 66}, },
            {{48, 122, -26}, },
            {{48, 122, -26}, },
            {{48, 100, -34}, {101, 101, 245}, {102, 122, 66}, },
            {{48, 102, -96}, {103, 103, 246}, {104, 122, 66}, },
            {{48, 98, -84}, {99, 99, 247}, {100, 122, 66}, },
            {{48, 115, -27}, {116, 116, 248}, {117, 122, 66}, },
            {{48, 90, -26}, {97, 97, 249}, {98, 122, 66}, },
            {{48, 122, -26}, },
            {{48, 122, -26}, },
            {{40, 40, 250}, {48, 122, -26}, },
            {{48, 122, -26}, },
            {{48, 90, -26}, {97, 97, 251}, {98, 122, 66}, },
            {{48, 107, -35}, {108, 108, 252}, {109, 122, 66}, },
            {{48, 100, -34}, {101, 101, 253}, {102, 122, 66}, },
            {{48, 110, -32}, {111, 111, 254}, {112, 122, 66}, },
            {{48, 107, -35}, {108, 108, 255}, {109, 122, 66}, },
            {{48, 104, -75}, {105, 105, 256}, {106, 122, 66}, },
            {{48, 115, -27}, {116, 116, 257}, {117, 122, 66}, },
            {{48, 113, -41}, {114, 114, 258}, {115, 122, 66}, },
            {{48, 122, -26}, },
            {{48, 122, -26}, },
            {{40, 40, 259}, {48, 122, -26}, },
            {{48, 107, -35}, {108, 108, 260}, {109, 122, 66}, },
            {{48, 90, -26}, {97, 108, 66}, {109, 109, 261}, {110, 122, 66}, },
            {{41, 41, 262}, },
            {{48, 103, -47}, {104, 104, 263}, {105, 122, 66}, },
            {{48, 110, -32}, {111, 111, 264}, {112, 122, 66}, },
            {{48, 109, -83}, {110, 110, 265}, {111, 122, 66}, },
            {{48, 115, -27}, {116, 116, 266}, {117, 122, 66}, },
            {{48, 109, -83}, {110, 110, 267}, {111, 122, 66}, },
            {{48, 122, -26}, },
            {{48, 66, -205}, {67, 67, 268}, {68, 122, -167}, },
            {{48, 107, -35}, {108, 108, 269}, {109, 122, 66}, },
            {{48, 103, -47}, {104, 104, 270}, {105, 122, 66}, },
            {{48, 122, -26}, },
            {{48, 122, -26}, },
            {{48, 110, -32}, {111, 111, 271}, {112, 122, 66}, },
            {{48, 122, -26}, },
            {{48, 109, -83}, {110, 110, 272}, {111, 122, 66}, },
            {{41, 41, 273}, },
            {{48, 114, -71}, {115, 115, 274}, {116, 122, 66}, },
            {{48, 115, -27}, {116, 116, 275}, {117, 122, 66}, },
            {{48, 122, -26}, },
            {{48, 90, -26}, {97, 119, 66}, {120, 120, 276}, {121, 122, 66}, },
            {{48, 107, -35}, {108, 108, 277}, {109, 122, 66}, },
            {{48, 109, -83}, {110, 110, 278}, {111, 122, 66}, },
            {{48, 113, -41}, {114, 114, 279}, {115, 122, 66}, },
            {{48, 104, -75}, {105, 105, 280}, {106, 122, 66}, },
            {{41, 41, 281}, },
            {{48, 109, -83}, {110, 110, 282}, {111, 122, 66}, },
            {{48, 122, -26}, },
            {},
            {{48, 90, -26}, {97, 97, 283}, {98, 122, 66}, },
            {{48, 116, -85}, {117, 117, 284}, {118, 122, 66}, },
            {{48, 115, -27}, {116, 116, 285}, {117, 122, 66}, },
            {{48, 113, -41}, {114, 114, 286}, {115, 122, 66}, },
            {{48, 122, -26}, },
            {{48, 110, -32}, {111, 111, 287}, {112, 122, 66}, },
            {{48, 110, -32}, {111, 111, 288}, {112, 122, 66}, },
            {{48, 122, -26}, },
            {{48, 111, -88}, {112, 112, 289}, {113, 122, 66}, },
            {{48, 122, -26}, },
            {},
            {{48, 104, -75}, {105, 105, 290}, {106, 122, 66}, },
            {{48, 122, -26}, },
            {{48, 122, -26}, },
            {{48, 104, -75}, {105, 105, 291}, {106, 122, 66}, },
            {{48, 100, -34}, {101, 101, 292}, {102, 122, 66}, },
            {{48, 104, -75}, {105, 105, 293}, {106, 122, 66}, },
            {{48, 90, -26}, {97, 97, 294}, {98, 122, 66}, },
            {},
            {{48, 122, -26}, },
            {{48, 113, -41}, {114, 114, 295}, {115, 122, 66}, },
            {{48, 97, -31}, {98, 98, 296}, {99, 122, 66}, },
            {{40, 40, 297}, {48, 122, -26}, },
            {{48, 104, -75}, {105, 105, 298}, {106, 122, 66}, },
            {{48, 107, -35}, {108, 108, 299}, {109, 122, 66}, },
            {{48, 116, -85}, {117, 117, 300}, {118, 122, 66}, },
            {{48, 120, -181}, {121, 121, 301}, {122, 122, 66}, },
            {{48, 109, -83}, {110, 110, 302}, {111, 122, 66}, },
            {{48, 111, -88}, {112, 112, 303}, {113, 122, 66}, },
            {{48, 122, -26}, },
            {{48, 109, -83}, {110, 110, 304}, {111, 122, 66}, },
            {{48, 109, -83}, {110, 110, 305}, {111, 122, 66}, },
            {{40, 40, 306}, {48, 122, -26}, },
            {{48, 107, -35}, {108, 108, 307}, {109, 122, 66}, },
            {{41, 41, 308}, },
            {{48, 109, -83}, {110, 110, 309}, {111, 122, 66}, },
            {{48, 110, -32}, {111, 111, 310}, {112, 122, 66}, },
            {{48, 113, -41}, {114, 114, 311}, {115, 122, 66}, },
            {{48, 122, -26}, },
            {{48, 102, -96}, {103, 103, 312}, {104, 122, 66}, },
            {{48, 114, -71}, {115, 115, 313}, {116, 122, 66}, },
            {{48, 102, -96}, {103, 103, 314}, {104, 122, 66}, },
            {{48, 102, -96}, {103, 103, 315}, {104, 122, 66}, },
            {{41, 41, 316}, },
            {{48, 100, -34}, {101, 101, 317}, {102, 122, 66}, },
            {},
            {{48, 102, -96}, {103, 103, 318}, {104, 122, 66}, },
            {{48, 116, -85}, {117, 117, 319}, {118, 122, 66}, },
            {{48, 122, -26}, },
            {{48, 122, -26}, },
            {{48, 100, -34}, {101, 101, 320}, {102, 122, 66}, },
            {{48, 122, -26}, },
            {{48, 107, -35}, {108, 108, 321}, {109, 122, 66}, },
            {},
            {{40, 40, 322}, {48, 122, -26}, },
            {{40, 40, 323}, {48, 122, -26}, },
            {{48, 113, -41}, {114, 114, 324}, {115, 122, 66}, },
            {{48, 122, -26}, },
            {{48, 100, -34}, {101, 101, 325}, {102, 122, 66}, },
            {{41, 41, 326}, },
            {{41, 41, 327}, },
            {{48, 122, -26}, },
            {{48, 122, -26}, },
            {},
            {},
        }
    };*/

    private static int[][] accept;
/*  {
        // INITIAL
        {-1, 1, 0, 0, 1, 33, -1, 84, -1, -1, 66, 67, 81, 77, 75, 79, 76, 82, 92, 74, 73, 85, 91, 87, 63, 63, 70, 71, 83, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 68, -1, 69, 0, 90, -1, 64, 30, -1, -1, 78, 80, 2, -1, 86, 89, 88, 63, 63, 63, 63, -1, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 13, 63, 63, 63, 63, 63, 31, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 22, 63, 63, 63, 63, 31, 65, -1, 65, -1, -1, -1, -1, -1, -1, 2, 2, 2, 93, 63, 72, 45, 63, 30, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 63, 35, 63, 63, 63, 63, 63, 42, 63, 63, 63, 21, 5, 63, 41, 33, 63, 63, 63, 63, 63, 63, 63, 34, 63, 63, 63, 36, 63, 63, 63, 32, 65, 2, 63, 38, 63, 37, 63, 39, 63, 63, 18, 47, 4, 63, 63, 63, 63, 63, 63, 63, 14, 63, 62, 63, 63, 29, 63, 63, 63, 63, 63, 63, 63, 40, 23, 63, 27, 8, 63, 63, 63, 63, 63, 19, 9, 63, 10, 63, 63, 63, 63, 63, 63, 63, 63, 28, 46, 63, 11, 63, -1, 63, 63, 63, 63, 63, 44, 63, 63, 63, 15, 7, 63, 25, 63, -1, 63, 63, 6, 63, 63, 63, 63, 63, -1, 63, 43, 48, 63, 63, 63, 63, 16, 63, 63, 17, 63, 3, 59, 63, 20, 54, 63, 63, 63, 63, 53, 12, 63, 63, 63, 63, 63, 63, 63, 63, 63, 57, 63, 63, 63, 63, -1, 63, 63, 63, 26, 63, 63, 63, 63, -1, 63, 49, 63, 63, 60, 24, 63, 58, 63, 52, 63, 63, 63, 56, 63, -1, -1, 61, 55, 50, 51, },

    };*/

    public static class State
    {
        public final static State INITIAL = new State(0);

        private int id;

        private State(int id)
        {
            this.id = id;
        }

        public int id()
        {
            return id;
        }
    }
}
